unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  StrUtils, Math,
  Dialogs, StdCtrls, uSKQ;

type
  TfmMain = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Memo1: TMemo;
    Edit3: TEdit;
    Label3: TLabel;
    Button2: TButton;
    Memo2: TMemo;
    Memo3: TMemo;
    Memo4: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmMain: TfmMain;
  hSKQ: THandle = 0;
  iSKQStatus: integer = 0;

//~~  ^Psu procedure ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
procedure OnConnection(iKind: Integer; iCode: Integer); stdcall; export;
procedure OnQuote(sMarket: SmallInt; sIndex: SmallInt); stdcall; export;
procedure OnTicks(sMarket: SmallInt; sIndex: SmallInt; iPtr: Integer); stdcall; export;
procedure OnBest5(sMarket: SmallInt; sIndex: SmallInt); stdcall; export;
procedure OnFutureTradeInfo( StockNo: PWideChar; sMarketNo: SmallInt; sStockidx: SmallInt;
  iBuyCount: Integer; iSellCount: Integer; iBuyQty: Integer; iSellQty: Integer;
  iBuyMatchCount: Integer; iSellMatchCount: Integer); stdcall; export;

implementation

{$R *.dfm}

procedure TfmMain.Button1Click(Sender: TObject);
begin
  if (Trim(Edit1.Text) = '') or (Trim(Edit2.Text) = '') then Exit;
  try
    if hSKQ <> 0 then
      FreeLibrary(hSKQ);
    hSKQ := LoadLibrary(SKQLib);
    if hSKQ <> 0 then
    begin
      @SKQuoteLib_Initialize := GetProcAddress(hSKQ, 'SKQuoteLib_Initialize');
      @SKQuoteLib_AttachConnectionCallBack := GetProcAddress(hSKQ, 'SKQuoteLib_AttachConnectionCallBack');
      @SKQuoteLib_AttachQuoteCallBack := GetProcAddress(hSKQ, 'SKQuoteLib_AttachQuoteCallBack');
      @SKQuoteLib_AttachTicksCallBack := GetProcAddress(hSKQ, 'SKQuoteLib_AttachTicksCallBack');
      @SKQuoteLib_AttachBest5CallBack := GetProcAddress(hSKQ, 'SKQuoteLib_AttachBest5CallBack');
      @SKQuoteLib_EnterMonitor := GetProcAddress(hSKQ, 'SKQuoteLib_EnterMonitor');
      @SKQuoteLib_LeaveMonitor := GetProcAddress(hSKQ, 'SKQuoteLib_LeaveMonitor');
      @SKQuoteLib_RequestStocks := GetProcAddress(hSKQ, 'SKQuoteLib_RequestStocks');
      @SKQuoteLib_RequestTicks := GetProcAddress(hSKQ, 'SKQuoteLib_RequestTicks');
      @SKQuoteLib_GetStockByNo := GetProcAddress(hSKQ, 'SKQuoteLib_GetStockByNo');
      @SKQuoteLib_GetStockByIndex := GetProcAddress(hSKQ, 'SKQuoteLib_GetStockByIndex');
      @SKQuoteLib_GetTick := GetProcAddress(hSKQ, 'SKQuoteLib_GetTick');
      @SKQuoteLib_GetBest5 := GetProcAddress(hSKQ, 'SKQuoteLib_GetBest5');
      @SKQuoteLib_AttachFutureTradeInfoCallBack := GetProcAddress( hSKQ, 'SKQuoteLib_AttachFutureTradeInfoCallBack');

      if (@SKQuoteLib_Initialize <> nil) and (@SKQuoteLib_AttachConnectionCallBack <> nil) and
        (@SKQuoteLib_AttachQuoteCallBack <> nil) and (@SKQuoteLib_AttachTicksCallBack <> nil) and
        (@SKQuoteLib_AttachBest5CallBack <> nil) and (@SKQuoteLib_EnterMonitor <> nil) and
        (@SKQuoteLib_RequestStocks <> nil) and (@SKQuoteLib_RequestTicks <> nil) and
        (@SKQuoteLib_GetStockByNo <> nil) and (@SKQuoteLib_GetStockByIndex <> nil) and
        (@SKQuoteLib_GetTick <> nil) and (@SKQuoteLib_GetBest5 <> nil) and ( @SKQuoteLib_AttachFutureTradeInfoCallBack <> nil)
        then
      begin
        iSKQStatus := SKQuoteLib_Initialize(Edit1.Text, Edit2.Text);
        iSKQStatus := iSKQStatus + SKQuoteLib_AttachConnectionCallBack(Integer(@OnConnection));
        iSKQStatus := iSKQStatus + SKQuoteLib_AttachQuoteCallBack(Integer(@OnQuote));
        iSKQStatus := iSKQStatus + SKQuoteLib_AttachTicksCallBack(Integer(@OnTicks));
        iSKQStatus := iSKQStatus + SKQuoteLib_AttachBest5CallBack(Integer(@OnBest5));
        iSKQStatus := iSKQStatus + SKQuoteLib_AttachFutureTradeInfoCallBack(Integer(@OnFutureTradeInfo));
        iSKQStatus := iSKQStatus + SKQuoteLib_EnterMonitor;
      end;
      if iSKQStatus <> 0 then
      begin
        FreeLibrary(hSKQ);
        Memo1.Lines.Add(FormatDateTime('hh:nn:ss:zzz ', now) + '-> ' + '  nJ~ !! ');
      end
      else
        Button1.Enabled := False;
    end;
  except
    FreeLibrary(hSKQ);
  end;
end;


procedure OnConnection(iKind, iCode: Integer);
//~~  su\
begin
  fmMain.Memo1.Lines.Add(FormatDateTime('hh:nn:ss:zzz ', now) + '-> ' + '  su\ !! (iKind = ' + IntToStr(iKind) + ', iCode = ' + IntToStr(iCode));
end;

procedure OnQuote(sMarket, sIndex: SmallInt);
//~~  q^
var iSt, j: integer;
  iDot: double;
  Page: Smallint;
  SK: TStock;
begin
  iSt := SKQuoteLib_GetStockByIndex(sMarket, sIndex, SK);
  if iSt = 0 then
  begin
    iDot := Power(10, SK.Decimal);
    fmMain.Memo1.Lines.Add(FormatDateTime('hh:nn:ss:zzz ', now) + '-> Quote : ' +
      intToStr(SK.Stockidx) + ', ' +
      intToStr(SK.Decimal) + ', ' +
      intToStr(SK.TypeNo) + ', ' +
      intToStr(SK.MarketNo) + ', ' +
      SK.StockNo + ', ' +
      SK.StockName + ', ' +
      FormatFloat('0.000', SK.Open / iDot) + ', ' +
      FormatFloat('0.000', SK.High / iDot) + ', ' +
      FormatFloat('0.000', SK.Low / iDot) + ', ' +
      FormatFloat('0.000', SK.Close / iDot) + ', ' +
      FormatFloat('0', SK.TickQty) + ', ' +
      FormatFloat('0.000', SK.Ref / iDot) + ', ' +
      FormatFloat('0.000', SK.Bid / iDot) + ', ' +
      FormatFloat('0', SK.Bc) + ', ' +
      FormatFloat('0.000', SK.Ask / iDot) + ', ' +
      FormatFloat('0', SK.Ac) + ', ' +
      FormatFloat('0', SK.TBc) + ', ' +
      FormatFloat('0', SK.TAc) + ', ' +
      FormatFloat('0', SK.FutureOI) + ', ' +
      FormatFloat('0', SK.TQty) + ', ' +
      FormatFloat('0', SK.YQty) + ', ' +
      FormatFloat('0.000', SK.Up / iDot) + ', ' +
      FormatFloat('0.000', SK.Down / iDot));
  end;
end;

procedure OnTicks(sMarket, sIndex: SmallInt; iPtr: Integer);
var iSt: integer;
  iDot: Double;
  Page: Smallint;
  SK: TStock;
  TK: TTick;
  sID, stmp: string;
begin
  iSt := SKQuoteLib_GetStockByIndex(sMarket, sIndex, SK);
  iSt := iSt + SKQuoteLib_GetTick(sMarket, sIndex, iPtr, TK);
  sID := Trim(SK.StockNo);
  if iSt = 0 then
  begin
    iDot := Power(10, SK.Decimal);
    fmMain.Memo2.Lines.Add(FormatDateTime('hh:nn:ss:zzz ', now) + '-> Ticks : ' + sID + ', ' +
      IntToStr(TK.Ptr) + ', ' + IntToStr(TK.Time) + ', ' +
      FormatFloat('0.000', TK.Bid / iDot) + ', ' +
      FormatFloat('0.000', TK.Ask / iDot) + ', ' +
      FormatFloat('0.000', TK.Close / iDot) + ', ' +
      IntToStr(TK.Qty));
  end
  else
    fmMain.Memo2.Lines.Add(FormatDateTime('hh:nn:ss:zzz ', now) + '-> Ticks : ' + sID + ', Error: ' + intToStr(iSt));
end;

procedure OnBest5(sMarket, sIndex: SmallInt);
//~~  ̨Τɦ^
var iSt: integer;
  iDot: Double;
  Page: Smallint;
  SK: TStock;
  B5: TBest5;
  sID, stmp: string;
begin
  iSt := SKQuoteLib_GetStockByIndex(sMarket, sIndex, SK);
  iSt := iSt + SKQuoteLib_GetBest5(sMarket, sIndex, B5);
  if iSt = 0 then
  begin
    iDot := Power(10, SK.Decimal);
    sID := Trim(SK.StockNo);

    fmMain.Memo3.Lines.Add(FormatDateTime('hh:nn:ss:zzz ', now) + '-> Best5 : ' + sID + ', ' +
      ifthen(B5.Bid1 < -9999, '0', FormatFloat('0.000', B5.Bid1 / iDot)) + ', ' +
      FormatFloat('0', B5.BidQty1) + ', ' +
      ifthen(B5.Bid2 < -9999, '0', FormatFloat('0.000', B5.Bid2 / iDot)) + ', ' +
      FormatFloat('0', B5.BidQty2) + ', ' +
      ifthen(B5.Bid3 < -9999, '0', FormatFloat('0.000', B5.Bid3 / iDot)) + ', ' +
      FormatFloat('0', B5.BidQty3) + ', ' +
      ifthen(B5.Bid4 < -9999, '0', FormatFloat('0.000', B5.Bid4 / iDot)) + ', ' +
      FormatFloat('0', B5.BidQty4) + ', ' +
      ifthen(B5.Bid5 < -9999, '0', FormatFloat('0.000', B5.Bid5 / iDot)) + ', ' +
      FormatFloat('0', B5.BidQty5) + ', ' +
      ifthen(B5.ExtendBid < -9999, '0', FormatFloat('0.000', B5.ExtendBid / iDot)) + ', ' +
      FormatFloat('0', B5.ExtendBidQty) + ', ' +

      ifthen(B5.Ask1 < -9999, '0', FormatFloat('0.000', B5.Ask1 / iDot)) + ', ' +
      FormatFloat('0', B5.AskQty1) + ', ' +
      ifthen(B5.Ask2 < -9999, '0', FormatFloat('0.000', B5.Ask2 / iDot)) + ', ' +
      FormatFloat('0', B5.AskQty2) + ', ' +
      ifthen(B5.Ask3 < -9999, '0', FormatFloat('0.000', B5.Ask3 / iDot)) + ', ' +
      FormatFloat('0', B5.AskQty3) + ', ' +
      ifthen(B5.Ask4 < -9999, '0', FormatFloat('0.000', B5.Ask4 / iDot)) + ', ' +
      FormatFloat('0', B5.AskQty4) + ', ' +
      ifthen(B5.Ask5 < -9999, '0', FormatFloat('0.000', B5.Ask5 / iDot)) + ', ' +
      FormatFloat('0', B5.AskQty5) + ', ' +
      ifthen(B5.ExtendAsk < -9999, '0', FormatFloat('0.000', B5.ExtendAsk / iDot)) + ', ' +
      FormatFloat('0', B5.ExtendAskQty));
  end;
end;

procedure OnFutureTradeInfo( StockNo: PWideChar; sMarketNo: SmallInt; sStockidx: SmallInt;
  iBuyCount: Integer; iSellCount: Integer; iBuyQty: Integer; iSellQty: Integer;
  iBuyMatchCount: Integer; iSellMatchCount: Integer);
begin
  fmMain.Memo4.Lines.Add( StockNo + '-> `eURi: ' + IntToStr( iBuyCount) +
    ', `eUX: ' + IntToStr( iSellCount) +
    ', `eURif: ' + IntToStr( iBuyQty) +
    ', `eUXf: ' + IntToStr( iSellQty) +
    ', `Ri: ' + IntToStr( iBuyMatchCount) +
    ', `X: ' + IntToStr( iSellMatchCount));

end;


procedure TfmMain.Button2Click(Sender: TObject);
var Page: Smallint;
begin
  if Trim(Edit3.Text) <> '' then
  begin
    iSKQStatus := SKQuoteLib_RequestStocks(Page, Edit3.Text);
    iSKQStatus := SKQuoteLib_RequestTicks(Page, Edit3.Text);
  end;
end;

procedure TfmMain.FormClose(Sender: TObject; var Action: TCloseAction);
var iST: integer;
begin
  if hSKQ <> 0 then
    iST := SKQuoteLib_LeaveMonitor;
end;

initialization

finalization
  FreeLibrary(hSKQ);

end.

