unit UCapital;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, ToolWin;

type
  TNotifyOrderStatus = procedure( Row, Code: integer; Mag: String) of object;

  TCapitalUI = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    ListView1: TListView;
    Panel1: TPanel;
    Label1: TLabel;
    edUserid: TEdit;
    Label2: TLabel;
    edPassword: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    ListView2: TListView;
    CoolBar1: TCoolBar;
    Panel2: TPanel;
    Button6: TButton;
    CoolBar2: TCoolBar;
    Panel3: TPanel;
    Button4: TButton;
    cbSymbol: TComboBox;
    rgTradeType: TRadioGroup;
    rgBuySell: TRadioGroup;
    edPrice: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    edQty: TEdit;
    ckDayTrade: TCheckBox;
    Label5: TLabel;
    Panel4: TPanel;
    Button7: TButton;
    Label6: TLabel;
    edTriggerPrice: TEdit;
    Button8: TButton;
    cbAccount: TComboBox;
    Label8: TLabel;
    ListView3: TListView;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure TabSheet3Show(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure ListView2KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure ListView3KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }

  public
    { Public declarations }
    procedure AddAccount( strAccount : String);
    procedure AddStopLossReport( strReport: String);

  end;

  function SKOrderLib_Initialize( Name: PAnsiChar; Password: PAnsiChar) : integer; stdcall; external 'SKOrderLib.dll';
  function RegisterOnAccountCallBack( CallBack : Pointer) : integer; stdcall; external 'SKOrderLib.dll';
  function GetUserAccount() : integer; stdcall; external 'SKOrderLib.dll';
  function SKOrderLib_ReadCertByID( ID: PAnsiChar) : integer; stdcall; external 'SKOrderLib.dll';
  // TradeType : 0: ROD, 1: IOC, 2: FOK
  // DayTrade: 0: No, 1: Yes
  // BuySell: 0: Buy, 1: Sell
  // Price: M 
  function SendFutureOrder( Account: PAnsiChar; Symbol : PAnsiChar; TradeType : Smallint;
       DayTrade : Smallint; BuySell : Smallint; Price : PAnsiChar; iQty: Integer;
       Msg : PAnsiChar; MsgLen : PInt) : integer; stdcall; external 'SKOrderLib.dll';

  function CancelOrderBySeqNo( Account: PAnsiChar; OrderNo: PAnsiChar): integer; stdcall; external 'SKOrderLib.dll';
  function CancelOrderByStockNo( Account: PAnsiChar; Symbol: PAnsiChar): integer; stdcall; external 'SKOrderLib.dll';

  // lBz
  function RegisterOnStopLossReportCallBack( CallBack : Pointer) : integer; stdcall; external 'SKOrderLib.dll';
  function GetStopLossReport( Account: PAnsiChar; RequestType:integer) : integer; stdcall; external 'SKOrderLib.dll';
  function SendFutureStopLoss( Account: PAnsiChar; Symbol : PAnsiChar; TradeType : Smallint;
       DayTrade : Smallint; BuySell : Smallint; Price : PAnsiChar; iQty: Integer;
       TriggerPrice : PAnsiChar; Msg : PAnsiChar; MsgLen : PInt) : integer; stdcall; external 'SKOrderLib.dll';
  // Юھڬdߦ^Ӫl椺e 
  function CancelFutureStopLoss( Account, BookNo, Symbol, BuySell, Price, Qty,
       TriggerPrice, TradeType, DayTrade:PAnsiChar;  Msg: PAnsiChar; MsgLen: PInt) : integer; stdcall; external 'SKOrderLib.dll';

{
SendStockOrder
SendOverseaFutureOrder
SendOptionOrder
OverseaCancelOrderBySeqNo
DecreaseOrderBySeqNo
OverseaDecreaseOrderBySeqNo
GetOverseaCount
GetOverseaProducts
SendStockOrderAsync
SendFutureOrderAsync
SendOptionOrderAsync
RegisterOnOpenInterestCallBack
GetOpenInterest
}

var
  CapitalUI: TCapitalUI;


implementation

{$R *.dfm}

const SK_SUCCESS : Integer                             = 0;
const SK_FAIL : Integer                                = -1;
const SK_ERROR_INITIALIZE_FAIL	: Integer               = -4;
const SK_ERROR_OVERSEA_ACCOUNT_NOT_EXIST : Integer     = -2;
const SK_ERROR_ACCOUNT_NOT_EXIST : Integer             = 1001;
const SK_ERROR_ACCOUNT_MARKET_NOT_MATCH : Integer      = 1002;
const SK_ERROR_PERIOD_OUT_OF_RANGE	: Integer           = 1003;
const SK_ERROR_FLAG_OUT_OF_RANGE : Integer             = 1004;
const SK_ERROR_BUYSELL_OUT_OF_RANGE : Integer          = 1005;
const SK_ERROR_ORDER_SERVER_INVALID : Integer          = 1006;
const SK_ERROR_PERMISSION_DENIED : Integer             = 1007;
const SK_ERROR_TRADE_TYPR_OUT_OF_RANGE	: Integer       = 1008;
const SK_ERROR_DAY_TRADE_OUT_OF_RANGE : Integer        = 1009;
const SK_ERROR_ORDER_SIGN_INVALID : Integer            = 1010;
const SK_ERROR_NEW_CLOSE_OUT_OF_RANGE : Integer        = 1011;
const SK_ERROR_PRODUCT_INVALID	: Integer               = 1012;
const SK_ERROR_QTY_INVALID	: Integer                   = 1013;
const SK_ERROR_DAYTRADE_DENIED	: Integer               = 1014;
const SK_ERROR_SPCIAL_TRADE_TYPE_INVALID : Integer     = 1015;
const SK_ERROR_PRICE_INVALID : Integer                 = 1016;
const SK_ERROR_INDEX_OUT_OF_RANGE : Integer            = 1017;
const SK_ERROR_QUERY_IN_PROCESSING	: Integer           = 1018;
const SK_ERROR_LOGIN_INVALID : Integer                 = 1019;
const SK_ERROR_REGISTER_CALLBACK : Integer             = 1020;


procedure OnAccount( bstrAccount : PWideChar); stdcall;
begin
   CapitalUI.AddAccount( WideString( bstrAccount));

end;

Procedure OnStopLossReport( bstrReport: PWideChar); stdcall;
begin
   CapitalUI.AddStopLossReport( WideString( bstrReport));


end;

procedure SeparateTerms(s : string;Separator : char;Terms : TStringList);
{ This browses a string and divide it into terms whenever the given
separator is found. The separators will be removed }
var
   hs : string;
   p : integer;
begin

   Terms.Clear; // First remove all remaining terms
   if Length(s)=0 then // Nothin' to separate
   Exit;

   p:=Pos(Separator,s);

   while P<>0 do
   begin
       hs:=Copy(s,1,p-1); // Copy term
       Terms.Add(hs); // Add to list
       Delete(s,1,p); // Remove term and separator
       p:=Pos(Separator,s); // Search next separator
   end;


   if Length(s)>0 then
   begin
       Terms.Add(s); // Add remaining term
   end;
end;

procedure TCapitalUI.Button1Click(Sender: TObject);
var
   iCode : integer;
begin
   edUserid.Text := Trim( edUserid.Text);
   edPassword.Text := Trim( edPassword.Text);

   iCode := SKOrderLib_Initialize( PAnsiChar( edUserid.Text) , PAnsiChar( edPassword.Text));

   if iCode <> SK_SUCCESS then
   begin
       ShowMessage( 'l, NX: ' + IntToStr( iCode));
   end
   else begin
       ShowMessage( 'bl\!');

       RegisterOnAccountCallBack( @OnAccount);
       RegisterOnStopLossReportCallBack( @OnStopLossReport);

       // Ūb
       Button2Click( nil);
       // Ū
       Button3Click( nil);

       edUserid.Text := '';
       edPassword.Text := '';

   end;

end;

procedure TCapitalUI.Button2Click(Sender: TObject);
begin
   // ob^ǥثeҦib
   GetUserAccount;
end;

procedure TCapitalUI.Button3Click(Sender: TObject);
var
   iCode : integer;
begin
   iCode := SKOrderLib_ReadCertByID( PAnsiChar( edUserid.Text));

   if iCode <> SK_SUCCESS then
   begin
       ShowMessage( 'Ū, NX: ' + IntToStr( iCode));
   end
   else
       ShowMessage( 'Ū\!');

end;

procedure TCapitalUI.Button4Click(Sender: TObject);
var
   i,j,k : integer;
   Item, ListItem : TListItem;
   iCode : integer;
   Account, Symbol,Price : String;
   strMsg : array[0..1023] of AnsiChar;
   iSize : integer;
begin

   if ckDayTrade.Checked then
   begin
       k:= 1;
   end
   else
       K:= 0;

   for i := 0 to ListView1.Items.Count-1 do
   begin
       Item := ListView1.Items.Item[i];

       for j := 0 to 2 do
       begin
           ListItem := ListView3.Items.Add;

           ListItem.Caption := Item.SubItems[0]+Item.Caption;
           ListItem.SubItems.Add( cbSymbol.Text);
           ListItem.SubItems.Add( rgBuySell.Items.Strings[ rgBuySell.ItemIndex]);
           ListItem.SubItems.Add( rgTradeType.Items.Strings[ rgTradeType.ItemIndex]);
           ListItem.SubItems.Add( edPrice.Text);
           ListItem.SubItems.Add( edQty.Text);
           ListItem.SubItems.Add( '');
           ListItem.SubItems.Add( '');

           Account :=Item.SubItems[0]+Item.Caption; // Account q+b
           Symbol := Trim( cbSymbol.Text);
           Price := Trim( edPrice.Text);

           strMsg := #0;
           iSize := 1023;

           iCode := SendFutureOrder(
             PAnsiChar( Account),
             PAnsiChar( Symbol),
             rgTradeType.ItemIndex,
             k,
             rgBuySell.ItemIndex,
             PAnsiChar( Price),
             StrToInt( edQty.Text),
             strMsg,
             @iSize);

             if (iCode <> SK_SUCCESS) and (iCode <> 5) {5Ow} then
             Begin
                 ListItem.SubItems.Strings[6] :=
                     'eU, Code: ' + IntToStr( iCode)+ ' ' + strMsg;
             End
             else
               ListItem.SubItems.Strings[5] := strMsg;
       end;
   end;

end;

procedure TCapitalUI.Button6Click(Sender: TObject);
var
   iCode : integer;
begin
   ListView2.Items.Clear;

   //0	eU
	//1	ĪeU

   iCode := GetStopLossReport( PAnsiChar( cbAccount.Text), 0);

end;

procedure TCapitalUI.Button7Click(Sender: TObject);
var
   i,j,k : integer;
   Item : TListItem;
   Rs : String;
   iCode : integer;
   Account, Symbol,Price,TPrice : String;
   strMsg : array[0..1023] of AnsiChar;
   iSize : integer;

begin
   if ckDayTrade.Checked then
   begin
       k:= 1;
   end
   else
       K:= 0;

   for i := 0 to ListView1.Items.Count-1 do
   begin
       Item := ListView1.Items.Item[i];

       for j := 0 to 2 do
       begin

               Account := Item.SubItems[0]+Item.Caption; // Account q+b
               Symbol := Trim( cbSymbol.Text);
               Price := Trim( edPrice.Text);
               TPrice := Trim( edTriggerPrice.Text);

           strMsg := #0;
           iSize := 1023;

           iCode := SendFutureStopLoss(
               PAnsiChar( Account),
               PAnsiChar( Symbol),
               rgTradeType.ItemIndex,
               k,
               rgBuySell.ItemIndex,
               PAnsiChar( Price),
               StrToInt( edQty.Text),
               PAnsiChar( Trim(TPrice)),
               strMsg,
               @iSize);

         if iCode <> SK_SUCCESS then
         Begin
           Rs := 'eU, Code: ' + IntToStr( iCode)+ #13 + String( strMsg);
         End;
       end;
   end;
end;

procedure TCapitalUI.Button8Click(Sender: TObject);
var
   iCode : integer;

begin
   iCode := CancelOrderByStockNo( PAnsiChar( cbAccount.Text), PAnsiChar( cbSymbol.Text));

   if iCode <> SK_SUCCESS then
   Begin
       ShowMessage( ', Code: ' + IntToStr( iCode));
   End;

end;

procedure TCapitalUI.FormCreate(Sender: TObject);
begin
   PageControl1.ActivePageIndex := 0;
end;

procedure TCapitalUI.ListView2KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
   strMsg : array[0..1023] of AnsiChar;

   strRs: String;

   ListItem: TListItem;
   iCode: integer;
   iSize : integer;
begin

   if Key = VK_DELETE then
   Begin
       strMsg := #0;
       iSize := 1023;

       ListItem := ListView2.Selected;

       if Assigned( ListItem) then
       begin

           iCode := CancelFutureStopLoss(
               PAnsiChar( ListItem.SubItems[1]),
               PAnsiChar( ListItem.SubItems[2]),
               PAnsiChar( ListItem.SubItems[3]),
               PAnsiChar( ListItem.SubItems[4]),
               PAnsiChar( ListItem.SubItems[5]),
               PAnsiChar( ListItem.SubItems[6]),
               PAnsiChar( ListItem.SubItems[8]),
               PAnsiChar( ListItem.SubItems[13]),
               PAnsiChar( ListItem.SubItems[14]),
               strMsg,
               @iSize);

           if iCode <> SK_SUCCESS then
           begin
               strRs := strMsg;
           end
           else
               Button6Click( nil);

       end;

   End;
end;

procedure TCapitalUI.ListView3KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
   ListItem: TListItem;
   iCode: integer;
begin
   { eUueXʧ@A Server ^AäOҨ\AЦۦT{^}
   if Key = VK_DELETE then
   Begin
       ListItem := ListView3.Selected;

       if Assigned( ListItem) and ( ListItem.SubItems.Strings[5] <> '') then
       begin
           iCode := CancelOrderBySeqNo(
               PAnsiChar( ListItem.Caption),
               PAnsiChar( ListItem.SubItems.Strings[5]));

           if iCode <> SK_SUCCESS then
           Begin
               ShowMessage( ', Code: ' + IntToStr( iCode));
           End
           else


       End;

   End;

end;

procedure TCapitalUI.TabSheet3Show(Sender: TObject);
var
   iCode : integer;
begin
   ListView2.Items.Clear;

   // 0	eU
   // 1	ĪeU
   iCode := GetStopLossReport( PAnsiChar( cbAccount.Text), 0);


end;

procedure TCapitalUI.AddAccount( strAccount : String);
var
   Items : TStringList;
   ListItem : TListItem ;
begin

   try
       Items := TStringList.Create;

       SeparateTerms( strAccount, ',', Items);

       // ҨB~fbBz
       if (Items[0] = 'OF') or (Items[0] = 'TS') then
       Exit;

       if ListView1.FindCaption( 0, Items[3], false, false, true) = nil then
       begin
           ListView1.Items.BeginUpdate;

           ListItem := ListView1.Items.Add;

           ListItem.Caption := Items[3];
           ListItem.SubItems.Add( Items[1]);
           ListItem.SubItems.Add( Items[2]);
           ListItem.SubItems.Add( Items[4]);

           cbAccount.Items.Add( Items[1]+Items[3]);

           if cbAccount.ItemIndex = -1 then
               cbAccount.ItemIndex := 0;

       end;

   finally
       ListView1.Items.EndUpdate;

       if Assigned( Items) then
           Items.Free;
   end;
end;

procedure TCapitalUI.AddStopLossReport( strReport: String);
var
   Items : TStringList;
   ListItem : TListItem;
   i: integer;
begin

   try
       Items := TStringList.Create;

       SeparateTerms( strReport, ',', Items);

       // pG^ǪĤ@ƬO "M" }YAܬ^ Message
       // ҥHN Message ܧYi
       if Pos( 'M',Items[0]) = 1 then
       begin
           MessageBox( Handle, PAnsiChar( Items[0]), 'T', MB_ICONASTERISK);

           Exit;
       end;

       ListView2.Items.BeginUpdate;

       ListItem := ListView2.Items.Add;

       ListItem.Caption := Items[0];

       for  i:= 1 to Items.Count- 1 do
       begin
           if (i=6) and (Trim(Items[i]) = '') then
           begin
               ListItem.SubItems.Add( 'M'); // 
           end
           else if (i=15) and (Trim(Items[i]) = '') then
           begin
               ListItem.SubItems.Add( 'N'); // DR
           end
           else
               ListItem.SubItems.Add( Trim(Items[i]));
       end;

   finally
       ListView2.Items.EndUpdate;

       if Assigned( Items) then
           Items.Free;
   end;

end;



end.


