#ifndef _Function_H_
#define _Function_H_

#define DLLImport _declspec(dllimport)


#define SK_SUCCESS								0
#define SK_FAIL									-1
#define SK_ERROR_INITIALIZE_FAIL				-4
#define SK_ERROR_OVERSEA_ACCOUNT_NOT_EXIST		-2
#define SK_ERROR_ACCOUNT_NOT_EXIST				1001
#define SK_ERROR_ACCOUNT_MARKET_NOT_MATCH		1002
#define SK_ERROR_PERIOD_OUT_OF_RANGE			1003
#define SK_ERROR_FLAG_OUT_OF_RANGE				1004
#define SK_ERROR_BUYSELL_OUT_OF_RANGE			1005
#define SK_ERROR_ORDER_SERVER_INVALID			1006
#define SK_ERROR_PERMISSION_DENIED				1007
#define SK_ERROR_TRADE_TYPR_OUT_OF_RANGE		1008
#define SK_ERROR_DAY_TRADE_OUT_OF_RANGE			1009
#define SK_ERROR_ORDER_SIGN_INVALID				1010
#define SK_ERROR_NEW_CLOSE_OUT_OF_RANGE			1011

#define SK_ERROR_PRODUCT_INVALID				1012
#define SK_ERROR_QTY_INVALID					1013
#define SK_ERROR_DAYTRADE_DENIED				1014
#define SK_ERROR_SPCIAL_TRADE_TYPE_INVALID		1015
#define SK_ERROR_PRICE_INVALID					1016
#define SK_ERROR_INDEX_OUT_OF_RANGE				1017
#define SK_ERROR_QUERY_IN_PROCESSING			1018
#define SK_ERROR_LOGIN_INVALID					1019
#define SK_ERROR_REGISTER_CALLBACK				1020
#define SK_ERROR_FUNCTION_PERMISSION_DENIED		1021
#define SK_ERROR_PERMISSION_TIMEOUT			    1022


struct SOfComProduct
{
   char m_strExchange[10]; ///< ҥN
   char m_strProductNo[10]; ///<ӫ~N
   char m_strYearMonth[10]; ///< ӫ~~

   unsigned short m_sSpecialTradeType;///<S
   double m_dMinJump; ///< I
   unsigned short m_nDenominator; ///< 

   unsigned short m_sDayTrade; ///< O_iR	
};

struct DataItem
{
   char caKeyNo[13];
   char caMarketType[2];                   // TS TA TL TF TO
   char cType;                             // N(new) C(cancel) U(update) D(deal) Q(quote)
   char cOrderErr;                         // Y N
   char caBroker[7];                       // TS,TA,TL is unit_no, TF,TO is broker
   char caCustNo[7];
   char caBuySell[3];                      // Ҩ B/S  0/2   0/1/2/3/4  v B/S  0/N/O 0/R/I/F
   char caExchangeID[7];                   // 
   char caComId[20];                       // e13Xӫ~N @Ӫť ᤻Xӫ~~
   char caStrikePrice[13];                 // i C
   char caOrderNo[5];
   char caPrice[13];                       // Ҩp, fTp,  KƤp
                                           // eUG9999999999999AleU  G
   char caNumerator[5];                    // lA3ơA2p
   char caDenominator[4];                  //  4
   char caPrice1[13];                      // KƤp eUGĲo  G0000000000000
   char caNumerator1[5];                   // l TƤGp
   char caDenominator1[4];                 //  |
   char caPrice2[13];                      // KƤp eUG0000000000000  G0000000000000
   char caNumerator2[5];                   // l TƤGp
   char caDenominator2[4];                 //  |

   char caQty[8];                          // Ѽ
   char caBeforeQty[4];
   char caAfterQty[4];
   char caDate[8];
   char caTime[6];
   char caOkSeq[8];                        // Ǹ
   char caSubID[7];
   char caSaleNo[4];
   char cAgent;
};

typedef struct DataItem TData;
typedef TData* LPDATA;


// import from SKOrderLib.dll

DLLImport int __stdcall SKOrderLib_Initialize( char* pcUserName, char* pcPassword);

DLLImport int __stdcall SKOrderLib_ReadCertByID( TCHAR* lpszUserID);

DLLImport int __stdcall SendStockOrder( const TCHAR* lpszAccount, const TCHAR* lpszStockNo, unsigned short usPeriod, unsigned short usFlag, 
	unsigned short usBuySell, const TCHAR* lpszPrice, int nQty, TCHAR* lpszMessage, int* pnMessageBufferSize);

DLLImport int __stdcall SendStockOrderAsync( const TCHAR* lpszAccount, const TCHAR* lpszStockNo, unsigned short usPeriod, 
	unsigned short usFlag, unsigned short usBuySell, const TCHAR* lpszPrice, int nQty);

DLLImport int __stdcall SendFutureOrder( const TCHAR* lpszAccount, const TCHAR* lpszStockNo, unsigned short usTradeType,
	unsigned short usDayTrade, unsigned short usBuySell, const TCHAR* lpszPrice, int nQty, TCHAR* lpszMessage, 
	int *pnMessageBufferSize);

DLLImport int __stdcall SendFutureOrderAsync( const TCHAR* lpszAccount, const TCHAR* lpszStockNo, unsigned short usTradeType,
	unsigned short usDayTrade, unsigned short usBuySell, const TCHAR* lpszPrice, int nQty);

DLLImport int __stdcall SendOptionOrder( const TCHAR* lpszAccount, const TCHAR* lpszStockNo, unsigned short usTradeType,
	unsigned short usNewClose, unsigned short usBuySell, const TCHAR* lpszPrice, int nQty, TCHAR* lpszMessage, 
	int *pnMessageBufferSize);

DLLImport int __stdcall SendOptionOrderAsync( const TCHAR* lpszAccount, const TCHAR* lpszStockNo, unsigned short usTradeType,
	unsigned short usNewClose, unsigned short usBuySell, const TCHAR* lpszPrice, int nQty);

DLLImport int __stdcall SendOverseaFutureOrder( const TCHAR* lpszAccount, const TCHAR* lpszTradeName, const TCHAR* lpszStockNo, const TCHAR* lpszYearMonth,
	unsigned short usBuySell, unsigned short usNewClose, unsigned short usDayTrade, unsigned short usTradeType, unsigned short usSpecialTradeType, int nQty,
	const TCHAR* lpszOrder,const TCHAR* lpszOrderNumerator,const TCHAR* lpszTrigger,const TCHAR* lpszTriggerNumerator,
    TCHAR* lpszMessage,	int *pnMessageBufferSize);

DLLImport int __stdcall SendOptionOrder( const TCHAR* lpszAccount, const TCHAR* lpszStockNo, unsigned short usTradeType,
	unsigned short usNewClose, unsigned short usBuySell, const TCHAR* lpszPrice, int nQty, TCHAR* lpszMessage, 
	int *pnMessageBufferSize);

DLLImport int __stdcall CancelOrderBySeqNo( const TCHAR* lpszAccount, const TCHAR* lpszSeqNo);

DLLImport int __stdcall CancelOrderByStockNo( const TCHAR* lpszAccount, const TCHAR* lpszStockNo);

DLLImport int __stdcall OverseaCancelOrderBySeqNo( const TCHAR* lpszAccount, const TCHAR* lpszSeqNo);

DLLImport int __stdcall DecreaseOrderBySeqNo( const TCHAR* lpszAccount, const TCHAR* lpszSeqNo, int nDecreaseQty);

DLLImport int __stdcall OverseaDecreaseOrderBySeqNo( const TCHAR* lpszAccount, const TCHAR* lpszSeqNo, int nDecreaseQty);

DLLImport int __stdcall GetOverseaCount();
DLLImport int __stdcall GetOverseaProducts(int index,struct SOfComProduct* product);

DLLImport int __stdcall RegisterOnOpenInterestCallBack( long lCallBackFunction);
DLLImport int __stdcall GetOpenInterest( TCHAR* lpszAccount);

DLLImport int __stdcall RegisterOnAccountCallBack( long lCallBackFunction);
DLLImport int __stdcall GetUserAccount();


DLLImport int __stdcall RegisterOnStopLossReportCallBack( long lCallBackFunction);
DLLImport int __stdcall GetStopLossReport( TCHAR* lpszAccount,int nReportStatus, TCHAR* lpszType);
	
DLLImport int __stdcall RegisterOnRealBalanceReportCallBack( long lCallBackFunction);
DLLImport int __stdcall GetRealBalanceReport( TCHAR* lpszAccount);
					

DLLImport int __stdcall SendFutureStopLoss( const TCHAR* lpszAccount, const TCHAR* lpszStockNo, unsigned short usTradeType,
	unsigned short usDayTrade, unsigned short usBuySell, const TCHAR* lpszPrice, int nQty, const TCHAR* lpszTrigger, 
	TCHAR* lpszMessage, int *pnMessageBufferSize);

DLLImport int __stdcall SendOptionStopLoss( const TCHAR* lpszAccount, const TCHAR* lpszStockNo, unsigned short usTradeType,
	unsigned short usDayTrade, unsigned short usBuySell, const TCHAR* lpszPrice, int nQty, const TCHAR* lpszTrigger, 
	TCHAR* lpszMessage, int *pnMessageBufferSize);

DLLImport int __stdcall SendMovingStopLoss( const TCHAR* lpszAccount, const TCHAR* lpszStockNo, unsigned short usTradeType,
	unsigned short usDayTrade, unsigned short usBuySell, const TCHAR* lpszPrice, int nQty, const TCHAR* lpszTrigger, 
	TCHAR* lpszMessage, int *pnMessageBufferSize);

DLLImport int __stdcall SendQuoteOrder( const TCHAR* lpszAccount, short sMarket, const TCHAR* lpszStockNo, 
	unsigned short usTradeType, const TCHAR* lpszBidPrice, int nBidQty, const TCHAR* lpszAskPrice,
	int nAskQty, TCHAR* lpszMessage, int* pnMessageBufferSize);

DLLImport int __stdcall CancelFutureStopLoss( const TCHAR* lpszAccount, const TCHAR* lpszBookNo,
   const TCHAR* lpszSymbol, const TCHAR* lpszBuySell, const TCHAR* lpszPrice,
   const TCHAR* lpszQty, const TCHAR* lpszTriggerPrice, const TCHAR* lpszTradeType, 
   const TCHAR* lpszDayTrade, TCHAR* lpszMessage, int* pnMessageBufferSize);

DLLImport int __stdcall CancelMovingStopLoss( const TCHAR* lpszAccount, const TCHAR* lpszBookNo,
   const TCHAR* lpszSymbol, const TCHAR* lpszBuySell, const TCHAR* lpszPrice,
   const TCHAR* lpszQty, const TCHAR* lpszTriggerPrice, const TCHAR* lpszTradeType, 
   const TCHAR* lpszDayTrade, TCHAR* lpszMessage, int* pnMessageBufferSize);

DLLImport int __stdcall CancelOptionStopLoss( const TCHAR* lpszAccount, const TCHAR* lpszBookNo,
   const TCHAR* lpszSymbol, const TCHAR* lpszBuySell, const TCHAR* lpszPrice,
   const TCHAR* lpszQty, const TCHAR* lpszTriggerPrice, const TCHAR* lpszTradeType, 
   const TCHAR* lpszDayTrade, TCHAR* lpszMessage, int* pnMessageBufferSize);

DLLImport int __stdcall CheckForeignStockOrderPara( const TCHAR* lpszAccount, const TCHAR* lpszStockNo,const TCHAR* lpszExchangeNo, unsigned short usBuySell, const TCHAR* lpszPrice, 
													 int nQty, const TCHAR* lpszCurrency1, const TCHAR* lpszCurrency2, const TCHAR* lpszCurrency3, int iAccountType , TCHAR* lpszMessage, int* pnMessageBufferSize);

DLLImport int __stdcall SendForeignStockOrder( const TCHAR* lpszAccount, const TCHAR* lpszStockNo,const TCHAR* lpszExchangeNo, 
			unsigned short usBuySell, const TCHAR* lpszPrice, int nQty,const TCHAR* lpszCurrency1, const TCHAR* lpszCurrency2, 
			const TCHAR* lpszCurrency3, int iAccountType, TCHAR* lpszMessage, int* pnMessageBufferSize);

DLLImport int __stdcall SendForeignStockOrderAsync( const TCHAR* lpszAccount, const TCHAR* lpszStockNo,const TCHAR* lpszExchangeNo, 
			unsigned short usBuySell, const TCHAR* lpszPrice, int nQty,const TCHAR* lpszCurrency1, const TCHAR* lpszCurrency2, const TCHAR* lpszCurrency3, int iAccountType, TCHAR* lpszMessage, int* pnMessageBufferSize);

DLLImport int __stdcall CancelForeignStockOrderByBookNo( const TCHAR* lpszAccount, const TCHAR* lpszBookNo,const TCHAR* lpszExchangeNo, TCHAR* lpszMessage, int* pnMessageBufferSize);

DLLImport int __stdcall CancelForeignStockOrderBySeqNo( const TCHAR* lpszAccount, const TCHAR* lpszSeqNo,const  TCHAR* lpszExchangeNo, TCHAR* lpszMessage, int* pnMessageBufferSize);

DLLImport int __stdcall GetEfficientForeignStockForInitial(const TCHAR* lpszStockNo);

DLLImport int __stdcall RegisterOnForeignStocksCallBack( long lCallBackFunction);

DLLImport void __stdcall GetOSStockNoandName();

DLLImport void __stdcall ErrorResult(TCHAR* lpszResult, TCHAR* lpszMessage, int* pnMessageBufferSize);

DLLImport int __stdcall SKOrderLib_InitializeTS( TCHAR* lpszTSCOMName);

DLLImport int __stdcall RegisterOnTSFilledOrderCallBack( long lCallBackFunction);
DLLImport int __stdcall RegisterOnTSActiveOrderCallBack( long lCallBackFunction);
DLLImport int __stdcall RegisterOnTSCanceledOrderCallBack( long lCallBackFunction);

// import from SKReplyLib.dll
DLLImport int __stdcall SKReplyLib_Initialize( const TCHAR* lpszUserName, const TCHAR* lpszPassword);
DLLImport int __stdcall RegisterOnConnectCallBack( long lCallBackFunction);
DLLImport int __stdcall RegisterOnDataCallBack( long lCallBackFunction);
DLLImport int __stdcall RegisterOnDisconnectCallBack( long lCallBackFunction);
DLLImport int __stdcall RegisterOnCompleteCallBack( long lCallBackFunction);

DLLImport int __stdcall SKReplyLib_Connect();
DLLImport int __stdcall SKReplyLib_ConnectByID( const TCHAR* lpszUserId);
DLLImport int __stdcall SKReplyLib_Close();
DLLImport int __stdcall SKReplyLib_IsConnected();

DLLImport int __stdcall SKReplyLib_CloseByID( const TCHAR* lpszUserId);
DLLImport int __stdcall SKReplyLib_IsConnectedByID( const TCHAR* lpszUserId);


#endif