// FutureStopLossDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ObjectTester.h"
#include "FutureStopLossDlg.h"
#include "FutureStoplossOrder.h"
#include "Functions.h"
#include "ObjectTesterDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFutureStopLossDlg dialog


CFutureStopLossDlg::CFutureStopLossDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFutureStopLossDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFutureStopLossDlg)
	//}}AFX_DATA_INIT
}


void CFutureStopLossDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFutureStopLossDlg)
	DDX_Control(pDX, IDC_StopLossReport, m_StopLossReportType);
	DDX_Control(pDX, IDC_Period2, m_Period);
	DDX_Control(pDX, IDC_Flag2, m_Flag);
	DDX_Control(pDX, IDC_BidAsk2, m_BidAsk);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFutureStopLossDlg, CDialog)
	//{{AFX_MSG_MAP(CFutureStopLossDlg)
	ON_BN_CLICKED(IDC_FUTURE_STOPLOSS, OnFutureStoploss)
	ON_BN_CLICKED(IDC_FUTURE_STOPLOSS2, OnFutureMovingStoploss)
	ON_BN_CLICKED(IDC_STOP_LOSS_REPORT, OnStopLossReport)
	ON_BN_CLICKED(IDC_STOP_LOSS_REPORT2, OnMovingStopLossReport)
	ON_BN_CLICKED(IDC_FUTURE_STOPLOSS_DELETE, OnFutureStoplossDelete)
	ON_BN_CLICKED(IDC_FUTURE_STOPLOSS_DELETE2, OnFutureMovingStoplossDelete)
	ON_BN_CLICKED(IDC_STOP_LOSS_REPORT3, OnStopLossReportAll)
	ON_BN_CLICKED(IDC_FUTRUE_MULTI_STOPLOSS, OnFutrueMultiStoploss)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFutureStopLossDlg message handlers

void CFutureStopLossDlg::SetAccount( const CString& strAccount)
{
	m_strAccount = strAccount;
}

void CFutureStopLossDlg::OnFutureStoploss() 
{
	// TODO: Add your control notification handler code here
	if ( m_strAccount.IsEmpty())
	{
		MessageBox( "Account is no Assigned");
		return;
	}

	int nSize = 1024;

	TCHAR caBuf[1024] = {0};
	
	CString strStockNo;
	CString strPrice;
	CString strQty;
	CString strTrigger;

	GetDlgItemText( IDC_StockNo2, strStockNo);
	GetDlgItemText( IDC_Price2, strPrice);
	GetDlgItemText( IDC_Qty2, strQty);
	GetDlgItemText( IDC_StopLoss, strTrigger);

	int nQty = atoi( strQty);

	int nBidAsk = m_BidAsk.GetCurSel();
	int nTradeType = m_Period.GetCurSel();
	int nDayTrade   = m_Flag.GetCurSel();

	int nCode = SendFutureStopLoss( 
		m_strAccount, 
		strStockNo, 
		nTradeType, 
		nDayTrade, 
		nBidAsk, 
		strPrice, 
		nQty, 
		strTrigger,
		caBuf, 
		&nSize);
		
	MessageBox( caBuf, "message", MB_ICONASTERISK|MB_TOPMOST);
}

void CFutureStopLossDlg::OnFutureMovingStoploss() 
{
	// TODO: Add your control notification handler code here
	if ( m_strAccount.IsEmpty())
	{
		MessageBox( "Account is no Assigned");
		return;
	}

	int nSize = 1024;

	TCHAR caBuf[1024] = {0};

	CString strStockNo;
	CString strPrice;
	CString strQty;
	CString strTrigger;

	GetDlgItemText( IDC_StockNo2, strStockNo);
	strPrice = "M";//ʰluaM
	GetDlgItemText( IDC_Qty2, strQty);
	GetDlgItemText( IDC_StopLoss3, strTrigger);


	int nQty = atoi( strQty);

	int nBidAsk = m_BidAsk.GetCurSel();
	int nTradeType = m_Period.GetCurSel();
	int nDayTrade   = m_Flag.GetCurSel();

	int nCode = SendMovingStopLoss( 
		m_strAccount, 
		strStockNo, 
		nTradeType, 
		nDayTrade, 
		nBidAsk, 
		strPrice, 
		nQty, 
		strTrigger,
		caBuf, 
		&nSize);
		
	MessageBox( caBuf, "message", MB_ICONASTERISK|MB_TOPMOST);
}

void __stdcall OnReturnStopLossReport( BSTR bstrData)
{
	CString strReport( bstrData);

	CObjectTesterDlg* pDlg = (CObjectTesterDlg*) AfxGetMainWnd();

	pDlg->AddReport( strReport);

}

void CFutureStopLossDlg::OnStopLossReport() 
{
	// TODO: Add your control notification handler code here
	RegisterOnStopLossReportCallBack( (long)OnReturnStopLossReport);

	int nReportType = m_StopLossReportType.GetCurSel();
	
	//CString strAccount;
	//GetDlgItemText( IDC_Account2, strAccount);

	TCHAR* cpAccount = new TCHAR[10];
	cpAccount = m_strAccount.GetBuffer(m_strAccount.GetLength());
	m_strAccount.ReleaseBuffer();

	GetStopLossReport(cpAccount,nReportType,"STP");
}

void CFutureStopLossDlg::OnMovingStopLossReport() 
{
	// TODO: Add your control notification handler code here
	RegisterOnStopLossReportCallBack( (long)OnReturnStopLossReport);

	int nReportType = m_StopLossReportType.GetCurSel();
		
	TCHAR* cpAccount = new TCHAR[10];
	cpAccount = m_strAccount.GetBuffer(m_strAccount.GetLength());
	m_strAccount.ReleaseBuffer();

	GetStopLossReport(cpAccount,nReportType,"MST");
}



void CFutureStopLossDlg::OnFutureStoplossDelete() 
{
	// TODO: Add your control notification handler code here	
	int nSize = 1024;
	TCHAR caBuf[1024] = {0};

	TCHAR* cpAccount = new TCHAR[10];
	cpAccount = m_strAccount.GetBuffer(m_strAccount.GetLength());
	m_strAccount.ReleaseBuffer();

	CString strBookNo = "0";
	GetDlgItemText( IDC_BookNO, strBookNo);

	//int nCode = CancelFutureStopLossByBookNo( cpAccount,strBookNo,caBuf,&nSize);
	int nCode = CancelFutureStopLoss( cpAccount,strBookNo,
		"0","0","0","0","0","0","0",
		caBuf,&nSize);

	MessageBox( caBuf, "message", MB_ICONASTERISK|MB_TOPMOST);
}

void CFutureStopLossDlg::OnFutureMovingStoplossDelete() 
{
	// TODO: Add your control notification handler code here
	int nSize = 1024;
	TCHAR caBuf[1024] = {0};

	TCHAR* cpAccount = new TCHAR[10];
	cpAccount = m_strAccount.GetBuffer(m_strAccount.GetLength());
	m_strAccount.ReleaseBuffer();

	CString strBookNo = "0";
	GetDlgItemText( IDC_BookNO, strBookNo);

	//int nCode = CancelMovingStopLossByBookNo( cpAccount,strBookNo,
	int nCode = CancelMovingStopLoss( cpAccount,strBookNo,
		"0","0","0","0","0","0","0",
		caBuf,&nSize);

	MessageBox( caBuf, "message", MB_ICONASTERISK|MB_TOPMOST);
}

void CFutureStopLossDlg::OnStopLossReportAll() 
{
	// TODO: Add your control notification handler code here
	RegisterOnStopLossReportCallBack( (long)OnReturnStopLossReport);

	int nReportType = m_StopLossReportType.GetCurSel();
	
	//CString strAccount;
	//GetDlgItemText( IDC_Account2, strAccount);

	TCHAR* cpAccount = new TCHAR[10];
	cpAccount = m_strAccount.GetBuffer(m_strAccount.GetLength());
	m_strAccount.ReleaseBuffer();
	
	GetStopLossReport(cpAccount,nReportType,"STP&MST");//dulvMuʰlv
}

void CFutureStopLossDlg::OnFutrueMultiStoploss() 
{
	// TODO: Add your control notification handler code here
	if ( m_strAccount.IsEmpty())
	{
		MessageBox( "Account is no Assigned");
		return;
	}
	
	int nSize = 1024;

	TCHAR caBuf[1024] = {0};
	
	CString strStockNo;
	CString strPrice;
	CString strQty;
	CString strTrigger;
	CString strCount;

	GetDlgItemText( IDC_StockNo2, strStockNo);
	GetDlgItemText( IDC_Price2, strPrice);
	GetDlgItemText( IDC_Qty2, strQty);
	GetDlgItemText( IDC_StopLoss, strTrigger);
	GetDlgItemText( IDC_StopLoss2, strCount);

	int nQty = atoi( strQty);

	int nBidAsk = m_BidAsk.GetCurSel();
	int nTradeType = m_Period.GetCurSel();
	int nDayTrade   = m_Flag.GetCurSel();	
	int nCount = atoi(strCount);

	for ( int i=0; i< nCount; i++)
	{
		CFutureStoplossOrder* pOrder = (CFutureStoplossOrder*) AfxBeginThread( 
			RUNTIME_CLASS( CFutureStoplossOrder), 
			THREAD_PRIORITY_TIME_CRITICAL,
			0,	
			CREATE_SUSPENDED,
			NULL);

		pOrder->m_strAccount = m_strAccount;
		pOrder->m_strStockNo = strStockNo;
		pOrder->m_strTrigger = strTrigger;
		pOrder->m_strPrice = strPrice; 
		
		pOrder->m_nTradeType = nTradeType; 
		pOrder->m_nDayTrade = nDayTrade; 
		pOrder->m_nBidAsk = nBidAsk; 
		pOrder->m_nQty = nQty; 

		pOrder->ResumeThread();
	}

}
