// ObjectTesterDlg.h : header file
//

#if !defined(AFX_OBJECTTESTERDLG_H__129CD188_C028_4324_A76C_A6E3AEBAACE6__INCLUDED_)
#define AFX_OBJECTTESTERDLG_H__129CD188_C028_4324_A76C_A6E3AEBAACE6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "StockDlg.h"
#include "FutureDlg.h"
#include "OptionDlg.h"
#include "ForeignStockDlg.h"
#include "FutureStopLossDlg.h"
#include "OptionStopLossDlg.h"

#include <vector>

using namespace std;

/////////////////////////////////////////////////////////////////////////////
// CObjectTesterDlg dialog

class CObjectTesterDlg : public CDialog
{

private:
	CStockDlg m_StockDlg;
	CFutureDlg m_FutureDlg;
	COptionDlg m_OptionDlg;
	ForeignStockDlg m_ForeignStockDlg;
	CFutureStopLossDlg m_FutureStopLossDlg;
	COptionStopLossDlg m_OptionStopLossDlg;


// Construction
public:
	CObjectTesterDlg(CWnd* pParent = NULL);	// standard constructor

	void AddReport( const CString& strReport);
	void AddAccount( const CString& strAccount);

	vector<CString> DivideByComma( CString strBuf);

// Dialog Data
	//{{AFX_DATA(CObjectTesterDlg)
	enum { IDD = IDD_OBJECTTESTER_DIALOG };
	CComboBox	m_ForeignStockAccountBox;
	CComboBox	m_ForeignAccountBox;
	CComboBox	m_FutureAccountBox;
	CComboBox	m_StockAccountBox;
	CTabCtrl	m_TabControl;
	CComboBox	m_StopLossReportType;
	CComboBox	m_Period5;
	CComboBox	m_Period4;
	CComboBox	m_NewTrade;
	CComboBox	m_Flag4;
	CComboBox	m_BidAsk4;
	CComboBox	m_Flag3;
	CComboBox	m_Flag2;
	CComboBox	m_Period3;
	CComboBox	m_Period2;
	CComboBox	m_BidAsk3;
	CComboBox	m_BidAsk2;
	CListBox	m_Reports;
	CComboBox	m_Flag;
	CComboBox	m_Period;
	CComboBox	m_BidAsk;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CObjectTesterDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CObjectTesterDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnUrlCrack();
	afx_msg void OnCancelOrder();
	afx_msg void OnOverseaCancelOrder();
	afx_msg void OnDecreaseOrder();
	afx_msg void OnOverseaDecreaseOrder();
	afx_msg void OnReplyConnect();
	afx_msg void OnClose();
	afx_msg void OnSendFutureOrder();
	afx_msg void OnSendOverseaFutureOrder();
	afx_msg void OnSendOptionOrder();
	afx_msg void OnUrl2();
	afx_msg void OnOpenInterest();
	afx_msg void OnGetAccount();
	afx_msg void OnGetStopLossReport();
	afx_msg void OnOptionStopLoss();
	afx_msg void OnOptionMovingStopLoss();
	afx_msg void OnOptionStopLossReport();
	afx_msg void OnMovingOptionStopLossReport();
	afx_msg void OnQuoteOrder();
	afx_msg void OnGetAllStopLossReport();
	afx_msg void OnSelchangingTab1(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelchangeTab1(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelchangeStockAccountbox();
	afx_msg void OnSelchangeFutureAccountbox();
	afx_msg void OnClear();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OBJECTTESTERDLG_H__129CD188_C028_4324_A76C_A6E3AEBAACE6__INCLUDED_)
