// StockDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ObjectTester.h"
#include "StockDlg.h"

#include "Functions.h"
#include "StockOrder.h"
#include "ObjectTesterDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStockDlg dialog


CStockDlg::CStockDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStockDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStockDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CStockDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStockDlg)
	DDX_Control(pDX, IDC_Period, m_Period);
	DDX_Control(pDX, IDC_Flag, m_Flag);
	DDX_Control(pDX, IDC_BidAsk, m_BidAsk);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStockDlg, CDialog)
	//{{AFX_MSG_MAP(CStockDlg)
	ON_BN_CLICKED(IDC_SendOrder, OnSendOrder)
	ON_BN_CLICKED(IDC_CancelOrderByStockNo, OnCancelOrderByStockNo)
	ON_BN_CLICKED(IDC_BUTTON1, OnSendStockOrderMultiple)
	ON_BN_CLICKED(IDC_REPORT, OnReport)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStockDlg message handlers

void CStockDlg::SetAccount( const CString& strAccount)
{
	m_strAccount = strAccount;
}

void CStockDlg::OnSendOrder() 
{
	// TODO: Add your control notification handler code here
	int nSize = 1024;

	TCHAR caBuf[1024] = {0};
	
//	TCHAR caAccount[16] = {0,};
//	TCHAR caStockNo[10] = {0,};
//	TCHAR caPrice[10] = {0,};

	//CString strAccount;
	CString strStockNo;
	CString strPrice;
	CString strQty;

	if ( m_strAccount.IsEmpty())
	{
		MessageBox( "Account is not assigned");
		return;
	}

	GetDlgItemText( IDC_StockNo, strStockNo);
	GetDlgItemText( IDC_Price, strPrice);
	GetDlgItemText( IDC_Qty, strQty);

	int nQty = atoi( strQty);

	int nBidAsk = m_BidAsk.GetCurSel();
	int nPeriod = m_Period.GetCurSel();
	int nFlag   = m_Flag.GetCurSel();

	int nCode = SendStockOrder( m_strAccount, strStockNo, nPeriod, nFlag, nBidAsk, strPrice, nQty, caBuf, &nSize);
		
	MessageBox( caBuf, "message", MB_ICONASTERISK|MB_TOPMOST);
	
}

void CStockDlg::OnCancelOrderByStockNo() 
{
	// TODO: Add your control notification handler code here
	//CString strAccount;
	//GetDlgItemText( IDC_Account, strAccount);

	CString strStockNo;
	GetDlgItemText( IDC_StockNo, strStockNo);

	int nCode = CancelOrderByStockNo( m_strAccount, strStockNo);
	
}

void CStockDlg::OnSendStockOrderMultiple() 
{
	// TODO: Add your control notification handler code here
	int nSize = 1024;

	TCHAR caBuf[1024] = {0};
	
//	TCHAR caAccount[16] = {0,};
//	TCHAR caStockNo[10] = {0,};
//	TCHAR caPrice[10] = {0,};

	CString strAccount;
	CString strStockNo;
	CString strPrice;
	CString strQty;

	for ( int i=0; i<10; i++)
	{
		CStockOrder* pOrder = (CStockOrder*) AfxBeginThread( 
			RUNTIME_CLASS( CStockOrder), 
			THREAD_PRIORITY_TIME_CRITICAL,
			0,	
			CREATE_SUSPENDED,
			NULL);

		GetDlgItemText( IDC_Account, pOrder->m_strAccount);
		GetDlgItemText( IDC_StockNo, pOrder->m_strStockNo);
		GetDlgItemText( IDC_Price, pOrder->m_strPrice);
		GetDlgItemText( IDC_Qty, strQty);

		int nQty = atoi( strQty);

		pOrder->m_nQty = nQty;

		pOrder->m_usBuySell = m_BidAsk.GetCurSel();
		pOrder->m_usPeriod  = m_Period.GetCurSel();
		pOrder->m_usFlag	= m_Flag.GetCurSel();

		pOrder->ResumeThread();
	}
	
}

void __stdcall OnReturnRealBalanceReport( BSTR bstrData)
{
	CString strReport( bstrData);

	CObjectTesterDlg* pDlg = (CObjectTesterDlg*) AfxGetMainWnd();

	pDlg->AddReport( strReport);

}

void CStockDlg::OnReport() 
{
	// TODO: Add your control notification handler code here
	RegisterOnRealBalanceReportCallBack( (long)OnReturnRealBalanceReport);

	//int nReportType = m_RealBalanceReportType.GetCurSel();
	
	//CString strAccount;
	//GetDlgItemText( IDC_Account2, strAccount);

	TCHAR* cpAccount = new TCHAR[10];
	cpAccount = m_strAccount.GetBuffer(m_strAccount.GetLength());
	m_strAccount.ReleaseBuffer();

	GetRealBalanceReport(cpAccount);
}
