// FutureDlg1.cpp : implementation file
//

#include "stdafx.h"
#include "ObjectTester.h"
#include "FutureDlg.h"

#include "FutureStoplossOrder.h"
#include "FutureOrder.h"
#include "Functions.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFutureDlg dialog


CFutureDlg::CFutureDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFutureDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFutureDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CFutureDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFutureDlg)
	DDX_Control(pDX, IDC_Flag2, m_Flag2);
	DDX_Control(pDX, IDC_Period2, m_Period2);
	DDX_Control(pDX, IDC_BidAsk2, m_BidAsk2);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFutureDlg, CDialog)
	//{{AFX_MSG_MAP(CFutureDlg)
	ON_BN_CLICKED(IDC_SendFutuerOrder, OnSendFutuerOrder)
	ON_BN_CLICKED(IDC_STOP_LOSS, OnStopLoss)
	ON_BN_CLICKED(IDC_MultiStoploss, OnMultiStoploss)
	ON_BN_CLICKED(IDC_Multiple, OnMultiple)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFutureDlg message handlers

void CFutureDlg::SetAccount( const CString& strAccount)
{
	m_strAccount = strAccount;
}

void CFutureDlg::OnSendFutuerOrder() 
{
	// TODO: Add your control notification handler code here
	if ( m_strAccount.IsEmpty())
	{
		MessageBox( "Account is no Assigned");
		return;
	}

	int nSize = 1024;

	TCHAR caBuf[1024] = {0};
	
//	TCHAR caAccount[16] = {0,};
//	TCHAR caStockNo[10] = {0,};
//	TCHAR caPrice[10] = {0,};

	CString strStockNo;
	CString strPrice;
	CString strQty;

	GetDlgItemText( IDC_StockNo2, strStockNo);
	GetDlgItemText( IDC_Price2, strPrice);
	GetDlgItemText( IDC_Qty2, strQty);

	int nQty = atoi( strQty);

	int nBidAsk = m_BidAsk2.GetCurSel();
	int nTradeType = m_Period2.GetCurSel();
	int nDayTrade   = m_Flag2.GetCurSel();

	int nCode = SendFutureOrder( m_strAccount, strStockNo, nTradeType, nDayTrade, nBidAsk, strPrice, nQty, caBuf, &nSize);
		
	MessageBox( caBuf, "message", MB_ICONASTERISK|MB_TOPMOST);
	
}

void CFutureDlg::OnStopLoss() 
{
	// TODO: Add your control notification handler code here
	if ( m_strAccount.IsEmpty())
	{
		MessageBox( "Account is no Assigned");
		return;
	}

	int nSize = 1024;

	TCHAR caBuf[1024] = {0};
	
//	TCHAR caAccount[16] = {0,};
//	TCHAR caStockNo[10] = {0,};
//	TCHAR caPrice[10] = {0,};

	CString strStockNo;
	CString strPrice;
	CString strQty;
	CString strTrigger;

	GetDlgItemText( IDC_StockNo2, strStockNo);
	GetDlgItemText( IDC_Price2, strPrice);
	GetDlgItemText( IDC_Qty2, strQty);
	GetDlgItemText( IDC_StopLoss, strTrigger);

	int nQty = atoi( strQty);

	int nBidAsk = m_BidAsk2.GetCurSel();
	int nTradeType = m_Period2.GetCurSel();
	int nDayTrade   = m_Flag2.GetCurSel();

	int nCode = SendFutureStopLoss( 
		m_strAccount, 
		strStockNo, 
		nTradeType, 
		nDayTrade, 
		nBidAsk, 
		strPrice, 
		nQty, 
		strTrigger,
		caBuf, 
		&nSize);
		
	MessageBox( caBuf, "message", MB_ICONASTERISK|MB_TOPMOST);
}

void CFutureDlg::OnMultiStoploss() 
{
	// TODO: Add your control notification handler code here
	if ( m_strAccount.IsEmpty())
	{
		MessageBox( "Account is no Assigned");
		return;
	}

	CString strStockNo;
	CString strPrice;
	CString strQty;
	CString strTrigger;
	CString strLoop;

	GetDlgItemText( IDC_StockNo2, strStockNo);
	GetDlgItemText( IDC_Price2, strPrice);
	GetDlgItemText( IDC_Qty2, strQty);
	GetDlgItemText( IDC_StopLoss, strTrigger);
	GetDlgItemText( IDC_StopLoss2, strLoop);

	int nQty = atoi( strQty);
	int nLoop = atoi( strLoop);

	int nBidAsk = m_BidAsk2.GetCurSel();
	int nTradeType = m_Period2.GetCurSel();
	int nDayTrade   = m_Flag2.GetCurSel();

	for ( int i=0; i<	nLoop; i++)
	{
		CFutureStoplossOrder* pOrder = (CFutureStoplossOrder*) AfxBeginThread( 
			RUNTIME_CLASS( CFutureStoplossOrder), 
			THREAD_PRIORITY_TIME_CRITICAL,
			0,	
			CREATE_SUSPENDED,
			NULL);

		pOrder->m_strAccount = m_strAccount;
		pOrder->m_strStockNo = strStockNo;
		pOrder->m_strTrigger = strTrigger;
		pOrder->m_strPrice = strPrice; 
		
		pOrder->m_nTradeType = nTradeType; 
		pOrder->m_nDayTrade = nDayTrade; 
		pOrder->m_nBidAsk = nBidAsk; 
		pOrder->m_nQty = nQty; 

		pOrder->ResumeThread();
	}
}

void CFutureDlg::OnMultiple() 
{
	// TODO: Add your control notification handler code here
	// TODO: Add your control notification handler code here
	if ( m_strAccount.IsEmpty())
	{
		MessageBox( "Account is no Assigned");
		return;
	}

	int nSize = 1024;

	TCHAR caBuf[1024] = {0};
	
//	TCHAR caAccount[16] = {0,};
//	TCHAR caStockNo[10] = {0,};
//	TCHAR caPrice[10] = {0,};

	CString strStockNo;
	CString strPrice;
	CString strQty;
	CString strLoop;

	GetDlgItemText( IDC_StockNo2, strStockNo);
	GetDlgItemText( IDC_Price2, strPrice);
	GetDlgItemText( IDC_Qty2, strQty);
	GetDlgItemText( IDC_Count, strLoop);

	int nQty = atoi( strQty);

	int nBidAsk = m_BidAsk2.GetCurSel();
	int nTradeType = m_Period2.GetCurSel();
	int nDayTrade   = m_Flag2.GetCurSel();
	int nLoop = atoi( strLoop);
	
	for ( int i=0; i<nLoop; i++)
	{
		CFutureOrder* pOrder = (CFutureOrder*) AfxBeginThread( 
			RUNTIME_CLASS( CFutureOrder), 
			THREAD_PRIORITY_TIME_CRITICAL,
			0,	
			CREATE_SUSPENDED,
			NULL);

		pOrder->m_strAccount = m_strAccount;
		pOrder->m_strStockNo = strStockNo;
		pOrder->m_strPrice = strPrice; 
		
		pOrder->m_nTradeType = nTradeType; 
		pOrder->m_nDayTrade = nDayTrade; 
		pOrder->m_nBidAsk = nBidAsk; 
		pOrder->m_nQty = nQty; 

		pOrder->ResumeThread();
	}


}
